<template>
  <!-- Input container -->
  <div :class="getElementCssClass('container')">
    <!--
      @slot Label slot
    -->
    <slot name="label">
      <div
        v-if="label.length > 0"
        :class="getElementCssClass('label')"
      >
        <label :for="name">{{ label }}</label>
        <span v-if="required"> *</span>
      </div>
    </slot>

    <t-textarea
      v-model="vModel"
      :disabled="disabled"
      :name="name"
      :variant="variant"
      :fixed-classes="tTextAreaStyle.fixedClasses"
      :classes="tTextAreaStyle.classes"
      :variants="tTextAreaStyle.variants"
      :required="required"
      :placeholder="placeholder"
      :autocomplete="autocomplete"
      :rows="rows"
      :cols="cols"
      :maxlength="maxlength"
      :style="{
        resize: resizeCSSValue
      }"
    />

    <!-- Textarea description -->
    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Description slot
      -->
      <slot
        v-if="description.length > 0"
        name="description"
      >
        <div :class="getElementCssClass('description')">
          <p>{{ description }}</p>
        </div>
      </slot>
    </transition>

    <!-- Textarea error -->
    <transition
      enter-active-class="_veryfast animated fadeIn"
      leave-active-class="_veryfast animated fadeOut"
    >
      <!--
        @slot Error slot
      -->
      <slot
        v-if="error.length > 0"
        name="error"
      >
        <div :class="getElementCssClass('error')">
          <p>{{ error }}</p>
        </div>
      </slot>
    </transition>
  </div>
</template>

<script>
import { utils } from '@hperchec/scorpion-ui'
// Components
import BaseInput from '../BaseInput'
// Style
import TextAreaStyle from './style'

const { typeCheck } = utils

/**
 * **TextArea** component
 * See also [vue-tailwind TTextArea documentation](https://www.vue-tailwind.com/docs/textarea)
 */
export default {
  name: 'TextArea',
  extends: BaseInput,
  props: {
    /**
     * Number of rows, see also https://developer.mozilla.org/fr/docs/Web/HTML/Element/textarea#rows
     * and vue-tailwind doc: https://www.vue-tailwind.com/docs/textarea/#props
     */
    rows: {
      type: String,
      default () {
        return '4'
      }
    },
    /**
     * Number of cols, see also https://developer.mozilla.org/fr/docs/Web/HTML/Element/textarea#cols
     * and vue-tailwind doc: https://www.vue-tailwind.com/docs/textarea/#props
     */
    cols: {
      type: String,
      default () {
        return '20'
      }
    },
    /**
     * Resize option, see also https://developer.mozilla.org/en-US/docs/Web/CSS/resize
     * If string, must be in: [ 'none', 'vertical', 'horizontal', 'both' ]
     * If boolean, true equals to 'both', false equals to 'none'
     */
    resize: {
      type: [ String, Boolean ],
      default () {
        return 'both' // default resize value for textarea
      },
      validator (value) {
        if (typeCheck(String, value)) {
          return [ 'none', 'vertical', 'horizontal', 'both' ].includes(value)
        } else {
          return typeCheck(Boolean, value)
        }
      }
    }
  },
  computed: {
    /**
     * ⚠ We have to flatten nested object because TTextArea original component requires
     * a one-level object as props for style
     * @returns {object} An object following VariantableOptions structure
     */
    tTextAreaStyle: function () {
      return {
        fixedClasses: this.overriddenStyle.fixedClasses.textarea,
        classes: this.overriddenStyle.classes.textarea,
        variants: Object.keys(this.overriddenStyle.variants).reduce((obj, variant) => {
          obj[variant] = this.overriddenStyle.variants[variant].textarea
          return obj
        }, {})
      }
    },
    /**
     * Returns the CSS value for "resize" prop based on "resize" prop value
     * @returns {string} CSS value
     */
    resizeCSSValue: function () {
      return typeCheck(String, this.resize)
        ? this.resize
        : this.resize
          ? 'both'
          : 'none'
    }
  },
  // Variantable option
  style: TextAreaStyle
}
</script>
